<template>
  <StyledDiv>
    <AtomButton
      type="primary"
      size="default"
      @click.native="onLogin"
      label="Log in"
      v-if="!user"
    />
    <AtomButton
      type="primary"
      size="default"
      @click.native="onLogout"
      label="Log out"
      v-if="user"
    />
    <AtomButton
      type="outlined"
      size="default"
      @click.native="onSignup"
      label="Sign up"
      v-if="!user"
    />
  </StyledDiv>
</template>

<script lang="ts">
import AtomButton from '../../Atoms/AtomButton/AtomButton.vue';
import StyledDiv from '../../../styles/Molecules/MoleculeHeaderUser/MoleculeHeaderUser';

export default {
  name: 'MoleculeHeaderUser',

  components: { AtomButton, StyledDiv },

  props: {
    user: {
      type: Object,
    },
  },

  methods: {
    onLogin(): void {
      alert('LOGIN');
    },
    onLogout(): void {
      // alert('LOGOUT');
    },
    onSignup(): void {
      alert('SIGNUP');
    },
  },

  async created(): Promise<any> {
    // POST request using fetch with error handling
    const requestOptions = {
      method: 'POST',
      headers: { 'Content-Type': 'application/json' },
      body: JSON.stringify({
        email: 'micheldelarocha@gmail.com',
        doc: '123.123.123-33',
        username: 'micheldelarocha',
        password: '123123',
        name: 'Michel',
        lastname: 'de la Rocha',
        birthday: '20/02/2002',
      }),
    };
    const fetchResponse = await fetch(
      'https://reqres.in/api/users?page=2',
      requestOptions,
    )
      .then(async (response) => {
        const data = await response.json();

        // check for error response
        if (!response.ok) {
          // get error message from body or default to response status
          const error = (data && data.message) || response.status;
          return Promise.reject(error);
        }

        return data;
      })
      .catch((error) => {
        console.error('There was an error!', error);
        return error;
      });
    return fetchResponse;
  },
};
</script>
